/* * noVNC: HTML5 VNC client * Copyright (C) 2011 Joel Martin * Licensed under LGPL-3 (see LICENSE.txt) * * See README.md for usage and integration instructions. */
function Display(e){"use strict";function t(){Util.Debug(">> Display.constructor");var e,t,n,i,o=Util.Engine;if(!l.target)throw"target must be set";if("string"==typeof l.target)throw"target must be a DOM element";if(e=l.target,!e.getContext)throw"no getContext method";if(u||(u=e.getContext("2d")),Util.Debug("User Agent: "+navigator.userAgent),o.gecko&&Util.Debug("Browser: gecko "+o.gecko),o.webkit&&Util.Debug("Browser: webkit "+o.webkit),o.trident&&Util.Debug("Browser: trident "+o.trident),o.presto&&Util.Debug("Browser: presto "+o.presto),a.clear(),!("createImageData"in u))throw"Canvas does not support createImageData";for(l.render_mode="canvas rendering",null===l.prefer_js&&(Util.Info("Prefering javascript operations"),l.prefer_js=!0),g=u.createImageData(16,16),n=[],t=0;256>t;t+=1)n.push(255);try{i=e.style.cursor,changeCursor(l.target,n,n,2,2,8,8),e.style.cursor?(null===l.cursor_uri&&(l.cursor_uri=!0),Util.Info("Data URI scheme cursor supported")):(null===l.cursor_uri&&(l.cursor_uri=!1),Util.Warn("Data URI scheme cursor not supported")),e.style.cursor=i}catch(s){Util.Error("Data URI scheme cursor test exception: "+s),l.cursor_uri=!1}return Util.Debug("<< Display.constructor"),a}var n,i,o,s,r,a={},l={},u=null,c=0,d=0,h={x:0,y:0,w:0,h:0},p={x1:0,y1:0,x2:-1,y2:-1},m="",f=null,g=null,v=0,b=0;return Util.conf_defaults(l,a,e,[["target","wo","dom",null,"Canvas element for rendering"],["context","ro","raw",null,"Canvas 2D context for rendering (read-only)"],["logo","rw","raw",null,'Logo to display when cleared: {"width": width, "height": height, "data": data}'],["true_color","rw","bool",!0,"Use true-color pixel data"],["colourMap","rw","arr",[],"Colour map array (when not true-color)"],["scale","rw","float",1,"Display area scale factor 0.0 - 1.0"],["viewport","rw","bool",!1,"Use a viewport set with viewportChange()"],["width","rw","int",null,"Display area width"],["height","rw","int",null,"Display area height"],["render_mode","ro","str","","Canvas rendering mode (read-only)"],["prefer_js","rw","str",null,"Prefer Javascript over canvas methods"],["cursor_uri","rw","raw",null,"Can we render cursor using data URI"]]),a.get_context=function(){return u},a.set_scale=function(e){r(e)},a.set_width=function(e){a.resize(e,d)},a.get_width=function(){return c},a.set_height=function(e){a.resize(c,e)},a.get_height=function(){return d},r=function(e){var t,n,i,o,s=["transform","WebkitTransform","MozTransform",null];for(t=l.target,n=s.shift();n&&"undefined"==typeof t.style[n];)n=s.shift();return null===n?(Util.Debug("No scaling support"),void 0):("undefined"==typeof e?e=l.scale:e>1?e=1:.1>e&&(e=.1),l.scale!==e&&(l.scale=e,i=t.width-t.width*e,o=t.height-t.height*e,t.style[n]="scale("+l.scale+") translate(-"+i+"px, -"+o+"px)"),void 0)},s=function(e){var t,n;t=l.true_color?e:l.colourMap[e[0]],n="rgb("+t[2]+","+t[1]+","+t[0]+")",n!==m&&(u.fillStyle=n,m=n)},a.viewportChange=function(e,t,n,i){var o,s,r,a,m,f,g,v=l.target,b=h,y=p,w=null;l.viewport||(Util.Debug("Setting viewport to full display region"),e=-b.w,t=-b.h,n=c,i=d),"undefined"==typeof e&&(e=0),"undefined"==typeof t&&(t=0),"undefined"==typeof n&&(n=b.w),"undefined"==typeof i&&(i=b.h),n>c&&(n=c),i>d&&(i=d),(b.w!==n||b.h!==i)&&(n<b.w&&y.x2>b.x+n-1&&(y.x2=b.x+n-1),b.w=n,i<b.h&&y.y2>b.y+i-1&&(y.y2=b.y+i-1),b.h=i,b.w>0&&b.h>0&&v.width>0&&v.height>0&&(w=u.getImageData(0,0,v.width<b.w?v.width:b.w,v.height<b.h?v.height:b.h)),v.width=b.w,v.height=b.h,w&&u.putImageData(w,0,0)),a=b.x+b.w-1,m=b.y+b.h-1,0>e&&b.x+e<0&&(e=-b.x),a+e>=c&&(e-=a+e-c+1),b.y+t<0&&(t=-b.y),m+t>=d&&(t-=m+t-d+1),(0!==e||0!==t)&&(Util.Debug("viewportChange deltaX: "+e+", deltaY: "+t),b.x+=e,a+=e,b.y+=t,m+=t,b.x>y.x1&&(y.x1=b.x),a<y.x2&&(y.x2=a),b.y>y.y1&&(y.y1=b.y),m<y.y2&&(y.y2=m),0>e?(s=0,f=-e):(s=b.w-e,f=e),0>t?(r=0,g=-t):(r=b.h-t,g=t),o=u.fillStyle,u.fillStyle="rgb(255,255,255)",0!==e&&(u.drawImage(v,0,0,b.w,b.h,-e,0,b.w,b.h),u.fillRect(s,0,f,b.h)),0!==t&&(u.drawImage(v,0,0,b.w,b.h,0,-t,b.w,b.h),u.fillRect(0,r,b.w,g)),u.fillStyle=o)},a.getCleanDirtyReset=function(){var e,t=h,n=p,i=[],o=t.x+t.w-1,s=t.y+t.h-1;return e={x:n.x1,y:n.y1,w:n.x2-n.x1+1,h:n.y2-n.y1+1},n.x1>=n.x2||n.y1>=n.y2?i.push({x:t.x,y:t.y,w:t.w,h:t.h}):(t.x<n.x1&&i.push({x:t.x,y:t.y,w:n.x1-t.x+1,h:t.h}),o>n.x2&&i.push({x:n.x2+1,y:t.y,w:o-n.x2,h:t.h}),t.y<n.y1&&i.push({x:n.x1,y:t.y,w:n.x2-n.x1+1,h:n.y1-t.y}),s>n.y2&&i.push({x:n.x1,y:n.y2+1,w:n.x2-n.x1+1,h:s-n.y2})),p={x1:t.x,y1:t.y,x2:t.x+t.w-1,y2:t.y+t.h-1},{cleanBox:e,dirtyBoxes:i}},a.absX=function(e){return e+h.x},a.absY=function(e){return e+h.y},a.resize=function(e,t){m="",c=e,d=t,r(l.scale),a.viewportChange()},a.clear=function(){l.logo?(a.resize(l.logo.width,l.logo.height),a.blitStringImage(l.logo.data,0,0)):(a.resize(640,20),u.clearRect(0,0,h.w,h.h))},a.fillRect=function(e,t,n,i,o){s(o),u.fillRect(e-h.x,t-h.y,n,i)},a.copyImage=function(e,t,n,i,o,s){var r=e-h.x,a=t-h.y,c=n-h.x,d=i-h.y;u.drawImage(l.target,r,a,o,s,c,d,o,s)},a.startTile=function(e,t,n,i,o){var s,r,c,d,h,p;if(v=e,b=t,f=16===n&&16===i?g:u.createImageData(n,i),s=f.data,l.prefer_js)for(r=l.true_color?o:l.colourMap[o[0]],c=r[2],d=r[1],h=r[0],p=0;4*n*i>p;p+=4)s[p]=c,s[p+1]=d,s[p+2]=h,s[p+3]=255;else a.fillRect(e,t,n,i,o)},a.subTile=function(e,t,n,i,o){var s,r,u,c,d,h,p,m,g,y,w;if(l.prefer_js)for(s=f.data,p=f.width,u=l.true_color?o:l.colourMap[o[0]],c=u[2],d=u[1],h=u[0],y=e+n,w=t+i,m=t;w>m;m+=1)for(g=e;y>g;g+=1)r=4*(g+m*p),s[r]=c,s[r+1]=d,s[r+2]=h,s[r+3]=255;else a.fillRect(v+e,b+t,n,i,o)},a.finishTile=function(){l.prefer_js&&u.putImageData(f,v-h.x,b-h.y)},n=function(e,t,n,i,o,s){var r,a,l,c,d=h;for(r=u.createImageData(n,i),c=r.data,a=0,l=s;4*n*i>a;a+=4,l+=3)c[a]=o[l],c[a+1]=o[l+1],c[a+2]=o[l+2],c[a+3]=255;u.putImageData(r,e-d.x,t-d.y)},i=function(e,t,n,i,o,s){var r,a,l,c,d=h;for(r=u.createImageData(n,i),c=r.data,a=0,l=s;4*n*i>a;a+=4,l+=4)c[a]=o[l+2],c[a+1]=o[l+1],c[a+2]=o[l],c[a+3]=255;u.putImageData(r,e-d.x,t-d.y)},o=function(e,t,n,i,o,s){var r,a,c,d,p,m;for(r=u.createImageData(n,i),d=r.data,m=l.colourMap,a=0,c=s;4*n*i>a;a+=4,c+=1)p=m[o[c]],d[a]=p[2],d[a+1]=p[1],d[a+2]=p[0],d[a+3]=255;u.putImageData(r,e-h.x,t-h.y)},a.blitImage=function(e,t,n,s,r,a){l.true_color?i(e,t,n,s,r,a):o(e,t,n,s,r,a)},a.blitRgbImage=function(e,t,i,s,r,a){l.true_color?n(e,t,i,s,r,a):o(e,t,i,s,r,a)},a.blitStringImage=function(e,t,n){var i=new Image;i.onload=function(){u.drawImage(i,t-h.x,n-h.y)},i.src=e},a.changeCursor=function(e,t,n,i,o,s){return l.cursor_uri===!1?(Util.Warn("changeCursor called but no cursor data URI support"),void 0):(l.true_color?changeCursor(l.target,e,t,n,i,o,s):changeCursor(l.target,e,t,n,i,o,s,l.colourMap),void 0)},a.defaultCursor=function(){l.target.style.cursor="default"},t()}function changeCursor(e,t,n,i,o,s,r,a){"use strict";var l,u,c,d,h,p,m,f,g,v,b=[];for(b.push16le=function(e){this.push(255&e,255&e>>8)},b.push32le=function(e){this.push(255&e,255&e>>8,255&e>>16,255&e>>24)},u=40,c=4*s*r,h=Math.ceil(s*r/8),d=Math.ceil(s*r/8),b.push16le(0),b.push16le(2),b.push16le(1),b.push(s),b.push(r),b.push(0),b.push(0),b.push16le(i),b.push16le(o),b.push32le(u+c+h+d),b.push32le(22),b.push32le(u),b.push32le(s),b.push32le(2*r),b.push16le(1),b.push16le(32),b.push32le(0),b.push32le(h+d),b.push32le(0),b.push32le(0),b.push32le(0),b.push32le(0),v=r-1;v>=0;v-=1)for(g=0;s>g;g+=1)m=v*Math.ceil(s/8)+Math.floor(g/8),f=128&n[m]<<g%8?255:0,a?(m=s*v+g,l=a[t[m]],b.push(l[2]),b.push(l[1]),b.push(l[0]),b.push(f)):(m=4*(s*v+g),b.push(t[m+2]),b.push(t[m+1]),b.push(t[m]),b.push(f));for(v=0;r>v;v+=1)for(g=0;g<Math.ceil(s/8);g+=1)b.push(0);for(v=0;r>v;v+=1)for(g=0;g<Math.ceil(s/8);g+=1)b.push(0);p="data:image/x-icon;base64,"+Base64.encode(b),e.style.cursor="url("+p+") "+i+" "+o+", default"}