/* * Websock: high-performance binary WebSockets * Copyright (C) 2011 Joel Martin * Licensed under LGPL-3 (see LICENSE.txt) * * Websock is similar to the standard WebSocket object but Websock * enables communication with raw TCP sockets (i.e. the binary stream) * via websockify. This is accomplished by base64 encoding the data * stream between Websock and websockify. * * Websock has built-in receive queue buffering; the message event * does not contain actual data but is simply a notification that * there is new data available. Several rQ* methods are available to * read binary data off of the receive queue. */
function Websock(){"use strict";function e(){return T}function t(){return x}function n(){return k}function i(e){k=e}function o(){return x.length-k}function s(){return x[k]}function r(){return x[k++]}function a(e){0===k?x.unshift(e):(k-=1,x[k]=e)}function l(){return(x[k++]<<8)+x[k++]}function u(){return(x[k++]<<24)+(x[k++]<<16)+(x[k++]<<8)+x[k++]}function c(e){"undefined"==typeof e&&(e=o());var t=x.slice(k,k+e);return k+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function d(e){return"undefined"==typeof e&&(e=o()),k+=e,x.slice(k-e,k)}function h(e,t){return t?x.slice(k+e,k+t):x.slice(k+e)}function p(e,t,n){var i=x.length-k;if(t>i){if(n){if(n>k)throw"rQwait cannot backup "+n+" bytes";k-=n}return!0}return!1}function m(){return Base64.encode(T)}function f(e){x=x.concat(Base64.decode(e,0))}function g(){return 0!==D.bufferedAmount&&Util.Debug("bufferedAmount: "+D.bufferedAmount),D.bufferedAmount<F.maxBufferedAmount?(T.length>0&&(D.send(m(T)),T=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+D.bufferedAmount),!1)}function v(e){return T=T.concat(e),g()}function b(e){F.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function y(e){try{f(e.data),o()>0?(B.message(),x.length>P&&(x=x.slice(k),k=0)):Util.Debug("Ignoring empty message")}catch(t){"undefined"!=typeof t.stack?Util.Warn("recv_message, caught exception: "+t.stack):"undefined"!=typeof t.description?Util.Warn("recv_message, caught exception: "+t.description):Util.Warn("recv_message, caught exception:"+t),"undefined"!=typeof t.name?B.error(t.name+": "+t.message):B.error(t)}}function w(e,t){B[e]=t}function A(){x=[],k=0,T=[],D=null}function C(e){A(),D=I?{}:new WebSocket(e,"base64"),D.onmessage=y,D.onopen=function(){Util.Debug(">> WebSock.onopen"),D.protocol&&Util.Info("Server chose sub-protocol: "+D.protocol),B.open(),Util.Debug("<< WebSock.onopen")},D.onclose=function(e){Util.Debug(">> WebSock.onclose"),B.close(e),Util.Debug("<< WebSock.onclose")},D.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),B.error(e),Util.Debug("<< WebSock.onerror")}}function _(){D&&((D.readyState===WebSocket.OPEN||D.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),D.close()),D.onmessage=function(){})}function S(e){return I=!0,F.send=e,F.close=function(){},y}function E(){return F.maxBufferedAmount=200,F.get_sQ=e,F.get_rQ=t,F.get_rQi=n,F.set_rQi=i,F.rQlen=o,F.rQpeek8=s,F.rQshift8=r,F.rQunshift8=a,F.rQshift16=l,F.rQshift32=u,F.rQshiftStr=c,F.rQshiftBytes=d,F.rQslice=h,F.rQwait=p,F.flush=g,F.send=v,F.send_string=b,F.on=w,F.init=A,F.open=C,F.close=_,F.testMode=S,F}var F={},D=null,x=[],k=0,P=1e4,T=[],B={message:function(){},open:function(){},close:function(){},error:function(){}},I=!1;return E()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),n="'></script>",i="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),i+=t+"web-socket-js/swfobject.js"+n,i+=t+"web-socket-js/web_socket.js"+n,document.write(i)}());